#ifndef EXCELENGINE_H
#define EXCELENGINE_H

#include <QObject>
#include <QFile>
#include <QString>
#include <QStringList>
#include <QVariant>
#include <QAxBase>
#include <QAxObject>

#include <QTableWidget>
#include <QTableView>
#include <QTableWidgetItem>
#include <QDebug>

typedef unsigned int UINT;

class excelengine : protected QObject
{
    Q_OBJECT
public:
    excelengine();
    excelengine(QString xlsFile);
    ~excelengine();
  public:
    bool Open(UINT nSheet = 1, bool visible = false);
    bool Open(QString xlsFile, UINT nSheet = 1, bool visible = false);
    void Save();
    void Close();

    bool SaveDataFrTable(QTableWidget *tableWidget);
    bool ReadDataToTable(QTableWidget *tableWidget);

    QVariant GetCellData(UINT row, UINT column);
    bool     SetCellData(UINT row, UINT column, QVariant data);

    UINT GetRowCount()const;
    UINT GetColumnCount()const;

    bool IsOpen();
    bool IsValid();

protected:
    void Clear();
private:
    QAxObject *pExcel;
    QAxObject *pWorkbooks;
    QAxObject *pWorkbook;
    QAxObject *pWorksheet;

    QString   sXlsFile;
    UINT      nCurrSheet;
    bool      bIsVisible;
    int       nRowCount;
    int       nColumnCount;
    int       nStartRow;
    int       nStartColumn;

    bool      bIsOpen;
    bool      bIsValid;
    bool      bIsANewFile;
    bool      bIsSaveAlready;

};

#endif // EXCELENGINE_H
